// in Public: DROP DOWN | WL CONVERT FUNCTION | NONE LOCKED | ROUNDED EDGES RECTANGLE

int helpDD (int phase)
{  
  pushStyle();
  noStroke();
  fill(150,235,0);
  if (phase==6)
  {
    DD_w=0;
    DD_h=0;
    phase=5;
  }
  if (phase==5)
  {
    roundRect (x, y, DD_w, 0);
    DD_w+=DD_v*(w-DD_w);
    if (DD_w>=w-1) phase=4;
  }
  if (phase==4)
  {
    roundRect (x, y, w, DD_h);
    DD_h+=DD_v*(hmax-DD_h);
    if (DD_h>=hmax-1)
    {
      phase=3;
      t0=millis();
    }
  }
  if (phase==3)
  {
    roundRect (x, y, w, DD_h);
    textFont (helv, 14);
    fill(0);
    text ("Dica: O menu\nAJUDA INTERATIVA\naparece no campo\ninferior esquerdo da\ntela da animação.",x+3, y+15);
    if ((millis()-t0)>tmax) phase=2;
  }
  if (phase==2)
  {
    roundRect (x, y, w, DD_h);
    DD_h-=DD_v*(DD_h);
    if (DD_h<0+1) phase=1;
  }
  if (phase==1)
  {
    roundRect (x, y, DD_w, 0);
    DD_w-=DD_v*(DD_w);
    if (DD_w<0+1) phase=-1;    // will be set to 0 when help mode is deactivated
  }
  popStyle();
  return phase;
}


boolean noneLocked ()
{
  return (!wlSource.isLocked() && !wlCat.isLocked() && !intensity.isLocked() && !fem.isLocked());
}

color convert (int Wavelength, int alphaset)
{
  float Gamma = 1.00;
  int IntensityMax = 255;
  float Blue, Green, Red;
  float Factor;
  
  color WLcor;
  
  if(Wavelength >= 350 && Wavelength <= 439)
  {
    Red	= map (Wavelength, 350, 440, 255, 0);
    Green = 0;
    Blue	= 255;
  }
  else if(Wavelength >= 440 && Wavelength <= 489)
  {
    Red	= 0;
    Green = map(Wavelength, 440, 490, 0, 255);
    Blue	= 255;
  }
  else if(Wavelength >= 490 && Wavelength <= 509)
  {
    Red = 0;
    Green = 255;
    Blue = map(Wavelength, 490, 510, 255, 0);
  }
  else if(Wavelength >= 510 && Wavelength <= 579)
  { 
    Red = map(Wavelength, 510, 580, 0, 255);
    Green = 255;
    Blue = 0;
  }
  else if(Wavelength >= 580 && Wavelength <= 644)
  {
    Red = 255;
    Green = map(Wavelength, 580, 645, 255, 0);
    Blue = 0.0;
  }
  else if(Wavelength >= 645 && Wavelength <= 780)
  {
    Red = 255;
    Green = 0.0;
    Blue = 0.0;
  }
  else
  {
    Red = 0.0;
    Green = 0.0;
    Blue = 0.0;
  }
  if(Wavelength >= 350 && Wavelength <= 419)
    Factor = 0.3 + 0.7*(Wavelength - 350) / (420 - 350);
  else if(Wavelength >= 420 && Wavelength <= 700)
    Factor = 1.0;
  else if(Wavelength >= 701 && Wavelength <= 780)
    Factor = 0.3 + 0.7*(780 - Wavelength) / (780 - 700);
  else
   Factor = 0.0;

  WLcor = color(round(Red*Factor), round(Green*Factor), round(Blue*Factor), alphaset);
  return WLcor;
}

void roundRect(float x, float y, float w, float h)
{
  rectMode(CORNER);

  float  ax, ay, hr, r;
  r=10;
  ax=x+w-1;
  ay=y+h-1;
  hr = r/2;

  rect(x, y, w, h);
  arc(x, y, r, r, radians(180.0), radians(270.0));
  arc(ax, y, r,r, radians(270.0), radians(360.0));
  arc(x, ay, r,r, radians(90.0), radians(180.0));
  arc(ax, ay, r,r, radians(0.0), radians(90.0));
  rect(x, y-hr, w, hr);
  rect(x-hr, y, hr, h);
  rect(x, y+h, w, hr);
  rect(x+w,y,hr, h);
} 


