float wlA, wlB, roam;
int photoact, direction, butSel ;
boolean click1, click2, runonce;

int tutorial (int tut)
{
  float Ox, Oy;
  float l, fontsize;

  Ox=(width-wT)/2;
  Oy=(height-hT)/2;

  if (tutNext.isSelected())
  {
    runonce=false;
    if (tut<12) tut++;
    else 
    {
      tutorial.unSelect();
    }
    tutNext.unSelect();
  }
  if (tutPrev.isSelected())
  {
    runonce=false;
    if (tut>1) tut--;
    tutPrev.unSelect();
  }


  pushMatrix();                        //PUSH A
  translate (Ox, Oy);
  fill (150,200,255);
  stroke(255);
  strokeWeight(3);
  rect (0,0, wT, hT);
  fill (0); 

  fill(0);
  textFont(verdanab, 20);
  textAlign (CENTER);
  text ("TUTORIAL", wT/2, 40);
  textSize(14);
//  text ("(em revisão)",wT/2+120, 38);

  textFont(helv, 18);
  text (tut+"/12", wT/2, hT-40);

  textAlign (LEFT);

  switch (tut)
  {
  case 1:
  case 2:

    if (tut==1)
      text ("Olá. Este tutorial irá guiá-lo pelas principais características da animação relacionadas ao Efeito\n"+
        "Fotoelétrico. Primeiro vamos entender o fenômeno que governa esse efeito.\n\n"+
        "                                                                              O  EFEITO  FOTOELÉTRICO\n\n"+
        "O Efeito Fotoelétrico consiste na emissão de elétrons pela superfície de um material, quando sobre  \n"+
        "ela incide radiação eletromagnética, como ilustrado na figura. Por simplicidade, e sem comprometer\n"+
        "a generalidade da explicação, consideraremos a radiação incidente monocromática.\n"+
        "\nTodos os materiais sólidos possuem uma \n"+
        "grandeza característica denominada \n"+
        "FUNÇÃO TRABALHO, que representa a \n"+
        "energia mínima necessária para libertar \n"+
        "os elétrons da superfície do  sólido. \n"+
        "Sabemos também, que a energia de um \n"+
        "fóton é igual à constante de Plank vezes a \n"+
        "frequência da radiação. Assim, a partir \n"+
        "da igualdade entre a função trabalho e a \n"+
        "energia do fóton, podemos definir uma \n"+
        "grandeza característica do processo, a \n"+
        "chamada FREQUÊNCIA DE CORTE."

        , 30,80);

    if (tut==2)
      text ("Quando a energia dos fótons da radiação incidente é maior que a função trabalho ou, equivalente-\n"+
        "mente, quando sua frequência é maior do que a de corte, elétrons podem ser emitidos da superfície\n"+
        "irradiada, sendo, nesse caso, chamados \"fotoelétrons\". A densidade dos fotoelétrons emitidos au -\n"+
        "menta com o aumento da intensidade da radiação incidente. Por outro lado, quando a energia dos  \n"+
        "fótons é menor que  a função trabalho, independentemente da intensidade da radiação incidente,  \n"+
        "elétrons não serão emitidos da superfície irradiada (vide figura).\n"+ 
        "\nPela explicação do Efeito Fotoelétrico, descoberto em 1839 por A. E. Becquerel e confirmado \n"+
        "em 1887 por Heinrich Hertz, Albert Einstein recebeu o Prêmio Nobel de Física de 1921.\n"+

        "\nEm nossa animação, consideramos apenas o\n"+
        "caso de emissores metálicos com radiação\n"+
        "eletromagnética monocromática limitada à\n"+
        "faixa de frequências do espectro visível,\n"+
        "isto é, do vermelho ao violeta."

        , 30,80);


    //image (tut11, 40, 300);
    image (tut12, 400, 285);
    textFont (helv, 12);
    textAlign(CENTER);
    text ("Wikimedia Commons - Photoelectric effect", 600,545);
    if (tut==2)
    {

      fill(150,200,255);
      noStroke();
      rect (610,280,150,174);
      fill(255,0,0);
    }
    else
    {
      fill(255,0,0);
      text ("Elétrons", 710, 300);
    }
    text ("Radiação Eletromagnética\n(fótons)", 470, 280);
    text ("Material Sólido", 710,520);
    break;

  case 3:

    text ("Agora, vamos descrever a área de da tela onde animamos o experimento que ilustra o Efeito Foto-\n"+
      "elétrico. Ela é composta de uma Câmara de Vácuo (1) dentro da qual temos: um Emissor (2), sólido de \n"+
      "metal em formato côncavo que recebe radiação proveniente da fonte luminosa localizada na regiao (5), \n"+
      "de um Coletor (8), eletrodo puntiforme que coleta elétrons liberados da superfície do emissor. Do lado\n"+
      "externo, temos um Amperímetro (6), que mede a corrente que passa pelo Circuito (7) e de uma Bateria,\n"+
      "(4) capaz de nele imprimir uma força eletro-motriz. Há ainda um indicador (3) que representa qual cor \n"+
      "do espectro visível é constituída de fótons que tem energia igual à da Função Trabalho do Emissor.\n"+
      "O circuito elétrico por onde flui a corrente é destacado em amarelo na figura."
      , 30,80);


    if (!runonce)
    {

      translate(0,40);

      image(Simulation, 180,210, 455, 325);
      pushStyle();

      fill (200,250,240,150);
      noStroke();
      rect(520,250,20,200);

      fill (200,250,240);
      stroke (30,255,170,150);
      strokeWeight(2);
      int radi=35;

      line (100,270,245,280);
      line (100,340,270,340);
      line (100,410,270,445);
      line (100,490,298,505);
      line (720,270,530,270);
      line (720,340,620,305);
      line (720,410,614,380);
      line (720,490,405,355);
      ellipse (100,270,radi, radi);
      ellipse (100,340,radi, radi);
      ellipse (100,410,radi, radi);
      ellipse (100,490,radi, radi);
      ellipse (720,270,radi, radi);
      ellipse (720,340,radi, radi);
      ellipse (720,410,radi, radi);
      ellipse (720,490,radi, radi);

      fill(0);
      textAlign(CENTER);
      text ("1", 100,275);
      text ("2", 100,345);
      text ("3", 100,415);
      text ("4", 100,495);
      text ("5", 720,275);
      text ("6", 720,345);
      text ("7", 720,415);
      text ("8", 720,495);

      noFill();
      stroke(255,255,0,100);
      strokeWeight(4);
      rect (195,355,419,158);




      popStyle();
    }




    break;

  case 4:

    text ("Relembrando, para que se observe a ocorrência do Efeito Fotoelétrico, a frequência dos fótons da\n"+
      "da radiação incidente sobre o emissor deve ser maior que a frequência de corte do emissor ou,\n"+
      "equivalentemente, a energia dos fótons incidentes deve ser maior que a função trabalho do emissor.\n"+
      "Por outro lado, quando os fotons possuem frequência menor que a de corte (ou seja, energia menor\n"+
      "que a função trabalho), não há liberação de elétrons a partir da superfície do emissor.\n"+
      "Nesta animação, a Função Trabalho do emissor, bem como a energia dos fótons incidentes são \n"+
      "representados por uma cor, que pode variar do vermelho ao violeta. Essas energias podem ser\n"+
      "ajustadas pelo usuário por meio dos controles \"Seletor de Cor da Fonte Luminosa\" e \"Seletor\n"+
      "da Função Trabalho do Emissor\", que possuem o aspecto da barra colorida mostrada abaixo.\n"+
      "Cada cor da barra corresponde a uma energia específica\n"+
      "ou, equivalentemente, a uma frequência específica.\n"+
      "Para alterar a energia, basta clicar o mouse sobre\n"+
      "a barra na cor desejada\n\n"+
      "Sabe-se que, de acordo com a equação de Plank, a energia \n"+
      "do fóton (E) e a frequência da radiação (f) são linearmente\n"+
      "proporcinais:\n"+
      "                                                       E = h f  ,\n"+
      "onde h=6,626068*10     m²kg/s é a constante de Plank. \n"+
      "Do comportamento ondulatório da radiação, temos que:\n"+
      "                                                        c = λ f  ,\n"+
      "onde c é a velocidade da luz e λ seu comprimento de onda.\n"
      , 30,80);
    noStroke();
    fill (255,150);
    rect (520, 280, 270, 270);
    fill(0);
    stroke(0);
    tutorialA.update();
    tutorialA.show();
    wlA= round(map(tutorialA.getVal(), 0, tutorialA.GetDim('h'), 380, 750));
    text ( "Comp. Onda = " + wlA + " nm", 650,380);
    text ( "Frequência    = " + nf(300000/wlA, 3, 1) + " THz", 650,450);
    text ( "Energia            = " + nf(300000/wlA*0.004135667, 1, 3) + " eV", 650,520);

    textSize (12);
    text ("-34", 255,500);


    //click1=false;
    //click2=false;
    //unonce=false;
    direction=3;

    break;

  case 7:
    click1=true;
    if (!runonce)
    { 
      click1=click2=false;
      tutorialA.setVal(45);
      tutorialB.setVal(10);
      runonce=true;
    }
  case 5:
    if (!runonce)
    { 
      click1=click2=false;
      runonce=true;
    }
  case 6:


    if (tut==5) {
      text ("Vamos analisar quais são os resultados da manipulação dos controles seletores de energia na\n"+
        "animação. O controle da direita foi associado à \"FUNÇÃO TRABALHO do EMISSOR\". Isso significa\n"+
        "que ele define a energia mínima para liberação de elétrons a partir da superfície do emissor. O  \n"+
        "controle da esquerda, por sua vez, representa a energia dos fótons da radiação incidente no emissor.\n"       
        , 30,80);
      text ("Altere a energia dos fótons incidentes (clicando na barra colorida da esquerda) e a função trabalho\n"+
        "do emissor (clicando na barra colorida da direita) e explore sua correlação com a ocorrência do\n"+
        "Efeito Fotoelétrico. Isso pode ser verificado observando-se a cor do indicador circular abaixo. \n"+
        "Quando o efeito fotoelétrico ocorre, o indicador possui cor verde e quando o efeito nao ocorre, \n"+
        "cor vermelha."
        , 30,180);
    }

    if (tut==6)
      text ("Além disso, no Efeito Fotoelétrico, quanto maior for a energia dos fótons da radiação incidente no \n"+
        "emissor, em relação à função trabalho do emissor, maior será a energia cinética máxima dos elétrons \n"+
        "liberados. Isso está ilustrado, na figura abaixo, pela barra amarela. Como é possível estimar mate- \n"+
        "maticamente  essa energia cinética? Será discutido adiante.\n\n"+
        "Altere a energia dos fótons incidentes e a função trabalho do emissor e explore sua correlação com\n"+
        "a energia cinética máxima dos elétrons liberados pelo emissor , representada pelo comprimento da\n"+
        "barra amarela"

        , 30,80);
    if (tut==7)
    {
      textSize(14);
    text ("Consideraremos agora a influência da intensidade da radiação emitida pela fonte luminosa no Efeito Fotoelétrico, que é controlada\n"+
      " na animação pelo dimmer \"Intensidade Luminosa\".\n"+
      "A frequência da radiação luminosa determina a energia dos fótons incidentes no emissor, enquanto a intensidade determina o fluxo\n"+
      "dos fótons incidentes. Quando a energia dos fótons é suficiente para originar o Efeito Fotoelétrico, o aumento da  intensidade \n"+
      "da radiação leva a um aumento da corrente de fotoelétrons gerada no circuito. No entanto, quando a energia dos fótons é inferior\n"+
      "à necessária para gerar o Efeito Fotoelétrico, a corrente de fotoelétrons é nula independentemente da intensidade da radiação\n"+
      "incidente no emissor. Na figura abaixo, o comprimento barra azul está correlacionado com a grandeza da corrente de fotoelétrons \n"+
      "no circuito. Usando os seletores de energia, escolha uma condição em que o Efeito Fotoelétrico ocorre (indicador verde e barra\n"+
      "                                                                                                                      amarela aparecem) e veja a influência da intensidade luminosa utilizando \n"+
      "                                                                                                                      o dimmer Intensidade Luminosa\". Repita o procedimento, escolhendo uma\n"+
      "                                                                                                                      condição em que o Efeito Fotoelétrico não ocorre (indicador vermelho)."
      , 30,80);
    }

    if(!click1 && tut!=7)        // sliding movement case 3 and 4 untill user clicks slider
    {
      if (!tutorialB.increment(direction)) direction*=-1;
      if (tutorialB.isLocked()) click1=true;
    }
    if(!click2 && tut==7)       // sliding movement case 5 untill user clicks slider
    {
      if (!tutorialC.increment(direction)) direction*=-1;
      if (tutorialC.isLocked()) click2=true;
    }


    noStroke();
    fill (255,150);
    rect (520, 280, 275, 270);
    rect (35, 280, 275, 270);
    fill(0);
    stroke(0);

    tutorialA.update();
    tutorialA.show();
    wlA= round(map(tutorialA.getVal(), 0, tutorialA.GetDim('h'), 380, 750));
    text ( "      Seletor da Função Trabalho do\n                         EMISSOR ( Φ )", 580,340);
    text ( "Comp. Onda = " + wlA + " nm", 650,420);
    text ( "Frequência    = " + nf(300000/wlA, 3, 1) + " THz", 650,480);
    text ( "Energia            = " + nf(300000/wlA*0.004135667, 1, 3) + " eV", 650,540);

    tutorialB.update();
    tutorialB.show();
    wlB= round(map(tutorialB.getVal(), 0, tutorialB.GetDim('h'), 380, 750));
    text ( "Seletor de Cor da fonte luminosa", 110,340);
    text ( "Comp. Onda = " + wlB + " nm", 120,420);
    text ( "Frequência    = " + nf(300000/wlB, 3, 1) + " THz", 120,480);
    text ( "Energia            = " + nf(300000/wlB*0.004135667, 1, 3) + " eV", 120,540);


    if (wlA>wlB) photoact=1;       // not emitting
    else photoact=0;               // emitting
    translate (Ox, Oy);
    translate (wT/2, 480);
    stroke(255);


    textAlign(CENTER);

    if(tut>5)
    { 
      stroke(255,230,0);
      strokeWeight(20);
      if (wlA>wlB)
      {

        line (0,-20,0,map(wlB-wlA, 0, 750-380, 0, 100)-20);          // kinetic energy indicator
      }
      fill(255,255,0);
      text ("Enegia\nCinética", 0, -155);
      fill(0);
    }
    if(tut>6)
    { 
      // pushStyle();
      textSize(13);
      text ("Intensidade\nLuminosa", -110, -240);
      stroke(0,0,255);
      strokeWeight(20);

      if (wlA>wlB)
      {
        //println (map(tutorialC.getVal(), 0, 100, 0, 20));
        line (10, 0, 10+map(wlB, 380, 750, 2.8,1)*map(tutorialC.getVal(), 0, 100, 0, 30), 0);          // current indicator
      }
      //popStyle();
      fill(0);
    }


    if (tut<7) {
      text ("Efeito\nFotoelétrico", 0, 50); 
      if (photoact==1) text ("ocorre", 0, 93);
      if (photoact==0) text ("não ocorre", 0, 93);
    }
    else { 
      fill(0,0,255);       
      text ("Corrente", 0, 50);
    }

    fill((1-photoact)*255, photoact*255, 0);
    strokeWeight(2);
    ellipse (0,0,40,40);

    if(tut>6)
    { 
      textSize(14);
      fill(0);
      text("0",-322,-247);
      text("100%",-170,-247);
      tutorialC.update();
      tutorialC.show();
    }

    textAlign(LEFT);
    break;

  case 8:
    pushStyle();
    textFont(helv, 16);
    text ("Para explicar o Efeito Fotoelétrico, isto é, a existência de uma frequência mínima (frequência de corte) da\n"+
      "radiação incidente no emissor, abaixo da qual não há geração de fotoelétrons, Einstein desenvolveu uma teoria\n"+
      "de que o feixe de luz pode ser pensado como sendo constituído por pacotes de energia, denominados fótons, \n"+
      " ou quanta. A energia de um fóton seria proporcional a sua frequência por uma constante 'h', a  constante de \n"+
      "Planck, de acordo com a relação E = hf, já apresentada (pág. 4). O processo de transferência de energia do fóton\n"+
      "ao elétron do emissor é um processo binário, ou seja, ou é transferida toda a energia do fóton para o elétron, ou\n"+
      "nenhuma energia é transferida. Além disso, um elétron não pode absorver simultaneamente a energia de mais de\n"+
      "um fóton. Abaixo é apresentada uma concepção artística tridimensional desse fenômeno. A esfera branca em\n"+
      "trajetória orbital representa o elétron exposto a fótons incidentes, com fluxo fixo, representadas pelas esferas\n"+
      "coloridas. Suponha que a função trabalho do emissor seja 2,3eV, que é a energia associada à luz verde.\n"+
      "Clique sobre os controles vermelho e azul abaixo, e veja o que acontece com as interações fóton-elétron:\n"        
      , 30,80);
    popStyle();
    text ("ENERGIA DOS FÓTONS", 300,320);
    fill(255,0,0);
    text ("<=  menor que", 260,338);
    fill(0,0,255);
    text ("maior que  =>", 430,338);
    fill(0);
    text ("/", 400,338);

    fill (20,160,0);
    text ("FUNÇÃO TRABALHO DO EMISSOR", 250,360);

    if (!runonce)
    {
      //println("RUNEI");
      catWL=530;
      blackout();  // limpa PGraphics Micro
      runonce=true;
    }

    if (butSel==0)
      fotIntensity=100./0;
    else fotIntensity=1;
    if (butSel==1)
      sourceWL=650;
    if (butSel==2)
      sourceWL=450;

    // MICRO control instance

    Micro.background(0);
    eelectron.update();
    eelectron.display();
    for (int i=0; i<ffotonN; i++)
    {
      ffoton[i].setWL(sourceWL);
      ffoton[i].update();
      ffoton[i].display();
    }

    if (frameCount%int(fotIntensity*4)==0 )
    {
      ffoton[ffotonIndex].trigger();
      ffotonIndex ++;
    }
    if (ffotonIndex >= ffotonN) ffotonIndex=0;

    image (Micro, 85, 370);
    butSel = tutButtons(runonce);



    break;

  case 9:
    pushStyle();
    textFont(helv, 16);
    text ("Já vimos que existe uma energia mínima que o fóton da radiação incidente deve apresentar para haver liberação\n"+
      "ção de elétrons na superfície do emissor, e que ela é definida pela frequência da radiação. Se o fóton possuir\n"+
      "energia maior do que a correspondente à frequência de corte, após a interação fóton-elétron, o elétron terá energia\n"+
      "suficiente para se libertar da superfície do emissor, além de energia adicional na forma de energia cinética. Como\n"+
      "conhecemos a energia dos fótons incidentes h.f, se aplicarmos uma diferença de voltagem desaceleradora entre\n"+
      "o emissor e o coletor de magnitude Vo tal que a velocidade dos elétrons se anule ao chegar ao coletor, podemos\n"+
      "estimar a energia cinética inicial Kmax dos elétrons, pois \n"+
      "                                                                                                                                              Kmax  = e.Vo = h.f - Φ \n\n"+
      "                                                                                                      Note que a diferença de voltagem Vo (Potencial de corte)\n"+
      "                                                                                                      independe da radiação incidente."
      , 30,70);

    /*text ("onde Vo é o POTENCIAL DE CORTE, a partir do qual \n"+
     "a corrente cessa, pois os elétrons estão sendo acelerados \n"+
     "de volta para o Emissor e não conseguem chegar ao Coletor."
     , 320,250);*/

    /*text ("mas como\n"+
     "Kmax = mv²/2 = h.f - Φ\n\n"+
     "a equação fica\n\n"+
     "              e.Vo = h.f - Φ "
     , 30,340);  */

    //noFill();
    //stroke(0);
    //rect (46,414,150,30);

    text ("Varie os parâmetros \n"+
      "exibidos e observe seus\n"+ 
      "respectivos efeitos sobre\n"+
      "o valor do Potencial de \n"+
      "Corte (Vo)"
      , 30,400);     

    popStyle();

    if (!runonce) tutOverride=true;

    WLcor = convert(round(map(tutorialB.getVal(), 0, wlSource.GetDim('h'), 350, 780)), fotonAlpha);

    tutorialB.update();
    tutorialB.show();
    tutorialC.update();
    tutorialC.show();
    textSize(14);
    fill(0);
    text("0",147,268);
    text("100%",287,268);

    pushMatrix();
    text ("Intensidade\n   Luminosa", 184,320);
    translate (330, 480);
    rotate(-HALF_PI);
    text ("Sel. de Cor da\n Fonte Luminosa", -20, -20);
    popMatrix();    // trocar esses dois por um translate incremental

    noStroke();
    fill (90,170,205);
    rect (410,350,330,220);
    fill(0);

    pushMatrix();
    translate (400,-280);
    scale(1.2);
    drawGraphic(fem.getVal(), tutorialB.getVal(), tutorialC.getVal());

    popMatrix();

    break;

  case 10:
    text ("Finalmente, o termina-se a montagem do circuito com o Amperímetro.\n"+
      "Este instrumento nos dá a informação que fecha o experimento, a corrente \n"+
      "que passa pelo circuito. Esse é o principal dado de saída do experimento, \n"+
      "e relaciona-se à FEM aplicada no circuito. Ele permite a plotagem do gráfico \n"+
      "\"Corrente vs. Voltagem\", a partir  do qual identifica-se a Voltagem de Corte. \n\n"+
      "O funcionamento deste aparelho está correlacionado com quase \n"+
      "todas as outras variáveis da animação. Por esse motivo, deixamos ê\n"+
      "para que vocteste-o fora deste tutorial, que está quase no fim.\n\n\n"+
      "Por último, na página seguinte, apresentaremos as principais das \nutilidades práticas do Efeito Fotoelétrico."
      , 30,80);

    strokeWeight(0);
    translate(80,-38);
    buildAmp(g);

    break;

  case 11:

    text ("UTILIDADES", 358,70);

    text ("\n"+
      "1. FOTOMULTIPLICADORES: Tubos de vácuo, extremamente sensíveis à radiação eletro-\n"+
      "         magnética, tanto na região  visível do espectro, quanto nas suas vizinhanças. São capazes de \n"+
      "         multiplicar intensidades de radiação de até 100 milhões de vezes, por possuirem um alto ganho \n"+
      "         e pouco ruido. São de grande utilidade na área médica e nuclear.\n\n"+
      "2. SENSORES DE IMAGEM: Os sensores de imagem das primeiras câmeras filmadoras eletrônicas \n"+
      "         usavam fotomultiplicadores.\n\n"+
      "3. ESPETROSCOPIA FOTOELETRÔNICA : Em um ambiente de alto-vácuo, uma amostra é bom-\n"+
      "         bardeada por fótons de raios X de energia conhecida. Como a energia dos fotoelétrons\n"+
      "         emitidos é igual à energia dos fótons incidente menos a Função Trabalho do material da amostra,\n"+
      "         é possivel determinar a Função Trabalho, e assim, a identidade química do material.\n\n"+
      "4. ELETROSCÓPIO DE FOLHAS: Capaz de indicar a presença de carga elétrica, funciona pela \n"+
      "         repulsãodas finas folhas carregadas em seu interior. Quando o eletroscópio está carregado\n"+
      "         negativamente e é exposto à luz de frequência superior à frequência de corte do material das\n"+
      "         folhas, os elétrons são liberados das suas superfícies e o aparelho é descarregado, \n"+
      "         fazendo com que as folhas metálicas caiam.\n\n"+
      "4. VISÃO NOTURNA: A imagem de equipamentos de visão noturna é gerada a partir de fotoelétrons \n"+
      "         emitidos por um filme semicondutor, que colidem com uma tela revestida de fósforo, onde\n"+
      "         a imagem é gerada.\n"

      , 30,80);


    translate(80,-38);
    break;

  case 12:
    textFont (helv, 20);
    text ("Assim termina o Tutorial da Animação \"Efeito Fotoelétrico\".\n"+
      "Obrigado por acompanhar esta explicação e boa animação!", 150,150);

    break;
  }
  popMatrix();

  return tut;
}

int tutButtons (boolean runonce)
{
  float x1, y1, x2, y2, rad;
  color A, B;

  if (!runonce) selected=0;

  pushMatrix();
  pushStyle();
  resetMatrix();
  x1=250;
  x2=670;
  y1=y2=365;
  rad=40;

  if (mousePressed && sqrt((mouseX-x1)*(mouseX-x1)+(mouseY-y1)*(mouseY-y1))<=rad/2)
    selected=1;
  if (mousePressed && sqrt((mouseX-x2)*(mouseX-x2)+(mouseY-y2)*(mouseY-y2))<=rad/2)
    selected=2;

  A=B=color(100);
  if (selected==1) A=color (255,230,0);
  if (selected==2) B=color (255,230,0);

  stroke(A);
  fill(255,0,0);
  ellipse (x1, y1, rad, rad);
  stroke(B);
  fill(0,0,255);
  ellipse (x2, y2, rad, rad);

  popStyle();
  popMatrix();                  //POP A
  return selected;
}

